import { ActualProvider, DependencyProvider, Factory, NameSelector } from './types';
import { ILifetime } from './Lifetime';
declare type LifetimeProvider<T, E> = new (dependency: DependencyProvider<T, E>, providerName: string, factoryFunction: Factory<T, E>) => ILifetime<T, E>;
declare type ProviderProvider<E> = {
    prototype: E;
    name: string;
    new (): E;
};
declare type DependencyOptions<T, E> = {
    factory?: Factory<T, E>;
    selector?: NameSelector<T, E>;
};
export declare class Container<E> {
    private static provider?;
    static getOrCreate<T>(factory?: () => Container<T>): ActualProvider<T>;
    static getOrCreateAsync<T>(factory?: () => Promise<Container<T>>): Promise<ActualProvider<T>>;
    readonly template: E;
    private readonly lifetimes;
    private readonly dependencyToProvider;
    constructor(ProviderTemplate: ProviderProvider<E>);
    add<T>(Lifetime: LifetimeProvider<T, E>, Dependency: DependencyProvider<T, E>, options?: DependencyOptions<T, E>): void;
    tryAdd<T>(Lifetime: LifetimeProvider<T, E>, Dependency: DependencyProvider<T, E>, { factory, selector }?: DependencyOptions<T, E>): boolean;
    get<T>(item: NameSelector<T, E>): ILifetime<T, E> | undefined;
    remove<T>(item: NameSelector<T, E>): boolean;
    build(validate?: boolean): ActualProvider<E>;
    resolveProperty<T>(item?: NameSelector<T, E>, Dependency?: DependencyProvider<T, E>): string;
    private preBuildValidate;
}
export {};
