"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Scoped = void 0;
var Errors_1 = require("../Errors");
var Scoped = /** @class */ (function () {
    function Scoped(dependency, providerName, factory) {
        this.dependency = dependency;
        this.providerName = providerName;
        this.factory = factory;
    }
    Scoped.prototype.provide = function (originalProvider) {
        var _a;
        var _b = originalProvider._, _c = _b.validation, validate = _c.validate, singletonBlockingScope = _c.singletonBlockingScope, trail = _c.trail, create = _b.create, context = _b.context;
        if (context[this.providerName])
            return context[this.providerName];
        var provider = originalProvider;
        if (validate) {
            if (trail[this.providerName])
                throw new Errors_1.CircularDependencyError(this.providerName, this.providerName);
            if (singletonBlockingScope)
                throw new Errors_1.SingletonScopedDependencyError(singletonBlockingScope, this.providerName);
            provider = create({ validate: validate, singletonBlockingScope: singletonBlockingScope, trail: __assign(__assign({}, trail), (_a = {}, _a[this.providerName] = this.providerName, _a)) }, context);
        }
        return (context[this.providerName] = this.factory(provider));
    };
    return Scoped;
}());
exports.Scoped = Scoped;
