"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Singleton = void 0;
var Errors_1 = require("../Errors");
var Singleton = /** @class */ (function () {
    function Singleton(dependency, providerName, factory) {
        this.dependency = dependency;
        this.providerName = providerName;
        this.factory = factory;
    }
    Singleton.prototype.provide = function (originalProvider) {
        var _a;
        if (this.value)
            return this.value;
        var _b = originalProvider._, _c = _b.validation, validate = _c.validate, trail = _c.trail, create = _b.create, context = _b.context;
        var provider = originalProvider;
        if (validate) {
            if (trail[this.providerName])
                throw new Errors_1.CircularDependencyError(this.providerName, this.providerName);
            provider = create({
                validate: validate,
                singletonBlockingScope: this.providerName,
                trail: __assign(__assign({}, trail), (_a = {}, _a[this.providerName] = this.providerName, _a)),
            }, context);
        }
        return (this.value = this.factory(provider));
    };
    return Singleton;
}());
exports.Singleton = Singleton;
