"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transient = void 0;
var Errors_1 = require("../Errors");
var Transient = /** @class */ (function () {
    function Transient(dependency, providerName, factory) {
        this.dependency = dependency;
        this.providerName = providerName;
        this.factory = factory;
    }
    Transient.prototype.provide = function (originalProvider) {
        var _a;
        var _b = originalProvider._, _c = _b.validation, validate = _c.validate, trail = _c.trail, singletonBlockingScope = _c.singletonBlockingScope, create = _b.create, context = _b.context;
        var provider = originalProvider;
        if (validate) {
            if (trail[this.providerName])
                throw new Errors_1.CircularDependencyError(this.providerName, this.providerName);
            provider = create({ validate: validate, singletonBlockingScope: singletonBlockingScope, trail: __assign(__assign({}, trail), (_a = {}, _a[this.providerName] = this.providerName, _a)) }, context);
        }
        return this.factory(provider);
    };
    return Transient;
}());
exports.Transient = Transient;
